## gdal 3.6.0+dfsg

=== frmts/fits/CMakeLists.txt ===
add_gdal_driver(TARGET gdal_FITS SOURCES fitsdataset.cpp PLUGIN_CAPABLE)
gdal_standard_includes(gdal_FITS)
gdal_target_link_libraries(gdal_FITS PRIVATE CFITSIO::CFITSIO)

=== frmts/iso8211/CMakeLists.txt ===
# This is common library for other driver. It is conditionally built.
# cf gdal.cmake for when it is built.
add_library(
  gdal_iso8211 OBJECT
  iso8211.h
  ddfmodule.cpp
  ddfutils.cpp
  ddffielddefn.cpp
  ddfrecord.cpp
  ddffield.cpp
  ddfsubfielddefn.cpp)
set_property(TARGET gdal_iso8211 PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:gdal_iso8211>)
gdal_standard_includes(gdal_iso8211)

# Because linking an OBJECT library
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.12)
    add_executable(8211dump EXCLUDE_FROM_ALL 8211dump.cpp)
    target_include_directories(8211dump PRIVATE $<TARGET_PROPERTY:gdal_iso8211,SOURCE_DIR>)
    target_link_libraries(8211dump PRIVATE $<TARGET_NAME:${GDAL_LIB_TARGET_NAME}> gdal_iso8211)

    add_executable(8211view EXCLUDE_FROM_ALL 8211view.cpp)
    target_include_directories(8211view PRIVATE $<TARGET_PROPERTY:gdal_iso8211,SOURCE_DIR>)
    target_link_libraries(8211view PRIVATE $<TARGET_NAME:${GDAL_LIB_TARGET_NAME}> gdal_iso8211)

    add_executable(8211createfromxml EXCLUDE_FROM_ALL 8211createfromxml.cpp)
    target_include_directories(8211createfromxml PRIVATE $<TARGET_PROPERTY:gdal_iso8211,SOURCE_DIR>)
    target_link_libraries(8211createfromxml PRIVATE $<TARGET_NAME:${GDAL_LIB_TARGET_NAME}> gdal_iso8211)
endif ()

=== frmts/msgn/CMakeLists.txt ===
add_gdal_driver(
  TARGET gdal_MSGN
  SOURCES msg_basic_types.cpp
          msg_basic_types.h
          msg_reader_core.cpp
          msg_reader_core.h
          msgndataset.cpp
          PLUGIN_CAPABLE
          NO_DEPS)
gdal_standard_includes(gdal_MSGN)
target_compile_definitions(gdal_MSGN PRIVATE -DGDAL_SUPPORT)
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.16)
  # These files has CPL_CVSID("$id$") which break ODR and UNITY_BUILD
  set_property(SOURCE msg_basic_types.cpp msgndataset.cpp msg_reader_core.cpp PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

=== frmts/rasdaman/CMakeLists.txt ===
add_gdal_driver(TARGET gdal_RASDAMAN SOURCES rasdamandataset.cpp rasdamandataset.h)
gdal_standard_includes(gdal_RASDAMAN)
target_include_directories(gdal_RASDAMAN PRIVATE ${RASDAMAN_INCLUDE_DIR})
gdal_target_link_libraries(gdal_RASDAMAN PRIVATE ${RASDAMAN_LIBRARY})

=== frmts/rmf/CMakeLists.txt ===
add_gdal_driver(
  TARGET gdal_RMF
  SOURCES rmfdataset.h
          rmfdataset.cpp
          rmfdem.cpp
          rmflzw.cpp
          rmfjpeg.cpp
          PLUGIN_CAPABLE
          NO_DEPS)
gdal_standard_includes(gdal_RMF)

if (HAVE_JPEG OR GDAL_USE_JPEG_INTERNAL)
  target_compile_definitions(gdal_RMF PRIVATE -DHAVE_LIBJPEG)
endif ()
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.16)
  # These files has CPL_CVSID("$id$") which break ODR and UNITY_BUILD
  set_property(SOURCE rmfdataset.cpp rmfdem.cpp rmflzw.cpp PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

=== ogr/ogrsf_frmts/CMakeLists.txt ===
include(GdalDriverHelper)

# ######################################################################################################################
# register all drivers
add_library(ogrsf_frmts OBJECT generic/ogrregisterall.cpp)
gdal_standard_includes(ogrsf_frmts)
target_include_directories(ogrsf_frmts PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                                               $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/generic>)
target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:ogrsf_frmts>)
set_property(TARGET ogrsf_frmts PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
add_dependencies(ogrsf_frmts generate_gdal_version_h)

# Obligatory for building GDAL; always compile in.
ogr_default_driver(mem "Read/write driver for MEMORY virtual files")
ogr_default_driver(geojson "GeoJSON/ESRIJSON/TopoJSON driver")
ogr_default_driver2(mitab TAB "MapInfo TAB and MIF/MID")
ogr_default_driver(shape "ESRI shape-file")

# ######################################################################################################################
ogr_default_driver(kml KML) # when not found EXPAT, it use CPL_MINIXML (ex. android)
ogr_default_driver(vrt "VRT - Virtual Format")

# Caution: if modifying AVC declaration here, also modify it in gdal.cmake
ogr_optional_driver(avc AVC)

ogr_optional_driver(gml GML) # when not found both EXPAT/XercesC, return error in driver, referenced by WCS

# ######################################################################################################################
ogr_optional_driver(csv CSV)
ogr_optional_driver(dgn DGN)
ogr_optional_driver(gmt GMT)
ogr_optional_driver(ntf NTF)
ogr_optional_driver(s57 S57)
ogr_optional_driver(tiger "U.S. Census TIGER/Line")
ogr_optional_driver(geoconcept GEOCONCEPT)
ogr_optional_driver(georss GEORSS)
ogr_optional_driver(dxf DXF)
ogr_optional_driver(pgdump PGDump)
ogr_optional_driver(gpsbabel GPSBABEL)
ogr_optional_driver(edigeo EDIGEO)
ogr_optional_driver(sxf SXF)
ogr_optional_driver(openfilegdb OPENFILEGDB)
ogr_optional_driver(wasp "WAsP .map format")
ogr_optional_driver(selafin OSELAFIN)
ogr_optional_driver(jml JML)
ogr_optional_driver(vdv "VDV-451/VDV-452/INTREST Data Format")
ogr_optional_driver(flatgeobuf FlatGeobuf)
ogr_optional_driver(mapml MapML)

# ######################################################################################################################
#

ogr_dependent_driver(sdts SDTS "GDAL_ENABLE_DRIVER_SDTS")

# XML drivers
ogr_dependent_driver(gpx "GPX - GPS Exchange Format" "GDAL_USE_EXPAT")
ogr_dependent_driver(gmlas GMLAS "GDAL_USE_XERCESC;OGR_ENABLE_DRIVER_PGDUMP")
ogr_dependent_driver(svg "Scalable Vector Graphics" "GDAL_USE_EXPAT")
ogr_dependent_driver(csw CSW "GDAL_USE_CURL")
ogr_dependent_driver(dwg DWG "GDAL_USE_TEIGHA")
ogr_dependent_driver(filegdb FileGDB "GDAL_USE_FILEGDB")
ogr_dependent_driver(libkml LibKML "GDAL_USE_LIBKML")
ogr_dependent_driver(nas "NAS/ALKIS" "GDAL_USE_XERCESC")
ogr_dependent_driver(plscenes PLSCENES "GDAL_USE_CURL")
ogr_dependent_driver(sosi "SOSI:Systematic Organization of Spatial Information" "GDAL_USE_FYBA")
ogr_dependent_driver(wfs "OGC WFS service" "GDAL_USE_CURL")
ogr_dependent_driver(ngw "NextGIS Web" "GDAL_USE_CURL")
ogr_dependent_driver(elastic "ElasticSearch" "GDAL_USE_CURL")

ogr_dependent_driver(idrisi IDRISI "GDAL_ENABLE_DRIVER_IDRISI")

ogr_dependent_driver(pds "Planetary Data Systems TABLE" "GDAL_ENABLE_DRIVER_PDS")

# Caution: if modifying SQLite declaration here, also modify it in gdal.cmake
ogr_dependent_driver(sqlite "SQLite3 / Spatialite RDBMS" "GDAL_USE_SQLITE3")
# Caution: if modifying GPKG declaration here, also modify it in gdal.cmake
ogr_dependent_driver(gpkg "GeoPackage" "GDAL_USE_SQLITE3;OGR_ENABLE_DRIVER_SQLITE")
ogr_dependent_driver(osm "OpenStreetMap XML and PBF" "GDAL_USE_SQLITE3;OGR_ENABLE_DRIVER_SQLITE")
ogr_dependent_driver(vfk "Czech Cadastral Exchange Data Format" "GDAL_USE_SQLITE3")
ogr_dependent_driver(mvt "MVT" "GDAL_USE_SQLITE3;OGR_ENABLE_DRIVER_OSM")

# ODBC/POSTGRES/MYSQL
ogr_dependent_driver(amigocloud AMIGOCLOUD "GDAL_USE_CURL;OGR_ENABLE_DRIVER_PGDUMP")
ogr_dependent_driver(carto CARTO "GDAL_USE_CURL;OGR_ENABLE_DRIVER_PGDUMP")
ogr_dependent_driver(ili ILI "GDAL_USE_XERCESC")
ogr_dependent_driver(mysql MySQL "GDAL_USE_MYSQL")
ogr_dependent_driver(pg PostGIS "GDAL_USE_POSTGRESQL;OGR_ENABLE_DRIVER_PGDUMP")
ogr_dependent_driver(mssqlspatial MSSQLSPATIAL "GDAL_USE_ODBC")
ogr_dependent_driver(odbc ODBC "GDAL_USE_ODBC")
ogr_dependent_driver(pgeo "PGEO" "GDAL_USE_ODBC")

ogr_dependent_driver(xlsx "Microsoft Office Excel(xlsx)" "GDAL_USE_EXPAT")
ogr_dependent_driver(xls "Microsoft Office Excel(xls)" "GDAL_USE_FREEXL")
ogr_dependent_driver(mongodbv3 "MongoDB V3" "GDAL_USE_MONGOCXX")
ogr_dependent_driver(cad "OpenCAD" "GDAL_USE_OPENCAD OR GDAL_USE_OPENCAD_INTERNAL")
ogr_dependent_driver(parquet "Parquet" "GDAL_USE_PARQUET")
ogr_dependent_driver(arrow "Arrow" "GDAL_USE_ARROW")

# ######################################################################################################################
# proprietary libraries
ogr_dependent_driver(oci "Oracle OCI" "GDAL_USE_ORACLE")
ogr_dependent_driver(idb "IDB" "GDAL_USE_IDB")
ogr_dependent_driver(ods ODS "GDAL_USE_EXPAT")
ogr_dependent_driver(ogdi "OGDI" "GDAL_USE_OGDI")
ogr_dependent_driver(lvbag "LVBAG" "GDAL_USE_EXPAT")
ogr_dependent_driver(hana "SAP HANA" "GDAL_USE_ODBCCPP;GDAL_USE_ODBC")

# Add generic in last line
add_subdirectory(generic)

=== swig/csharp/CMakeLists.txt ===
option(GDAL_CSHARP_ONLY "Compile C# bindings on existing GDAL installation" OFF)

if (GDAL_CSHARP_ONLY)
  find_package(GDAL REQUIRED)
else ()
  include(GdalStandardIncludes)
endif ()

if (CMAKE_CXX_FLAGS)
  string(REPLACE "-Werror " " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ")
  string(REPLACE "/WX " " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ")
endif ()

set(GDAL_CSHARP_INSTALL_DIR
    "${CMAKE_INSTALL_DATADIR}/csharp"
    CACHE PATH "Installation sub-directory for CSharp bindings")

set(CSHARP_LIBRARY_VERSION
    "net5.0"
    CACHE STRING ".NET version to be used for libraries")
set(CSHARP_APPLICATION_VERSION
    "net5.0"
    CACHE STRING ".NET version to be used for the sample Applications")
set(CSHARP_CONFIG
    "RELEASE"
    CACHE STRING "Config to be used to compile the C# artifacts > RELEASE|CONFIG")

set(_VERSION_STRING ${GDAL_VERSION_NO_DEV_SUFFIX})
if (GDAL_DEV_SUFFIX)
  set(_VERSION_STRING ${_VERSION_STRING}-${GDAL_DEV_SUFFIX})
endif ()

# based on https://stackoverflow.com/questions/39258250/how-to-detect-if-64-bit-msvc-with-cmake TODO - this not going to
# cope with ARM architectures
if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(CSHARP_RID "osx-x64")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(CSHARP_RID "linux-x64")
elseif ("${CMAKE_GENERATOR_PLATFORM}" STREQUAL "x64")
  set(CSHARP_RID "win-x64")
elseif ("${CMAKE_GENERATOR_PLATFORM}" STREQUAL "Win32")
  set(CSHARP_RID "win-x86")
endif ()

# needed because of differences in the packages
if (DOTNET_FOUND)
  set(CSHARP_DRAWING "System.Drawing.Common")
else ()
  set(CSHARP_DRAWING "System.Drawing")
endif ()

# setup local NuGet repository
if (DOTNET_FOUND)
  file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} _DN_REPO_PATH)
  dotnet_register_local_repository("local" ${_DN_REPO_PATH})
endif ()

# Cop[y build files
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gdal.snk ${CMAKE_CURRENT_BINARY_DIR}/gdal.snk COPYONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Directory.Build.props ${CMAKE_CURRENT_BINARY_DIR}/Directory.Build.props
               COPYONLY)

# Crate some placemarker packages for dependencies
if (DOTNET_FOUND)
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/osgeo.gdal.core.csproj.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/osgeo.gdal.core.csproj")
  add_dotnet(
    ${CMAKE_CURRENT_BINARY_DIR}/osgeo.gdal.core.csproj
    ${CSHARP_CONFIG}
    NAME
    OSGeo.GDAL.Core
    VERSION
    ${_VERSION_STRING}
    OUTPUT_PATH
    ${CMAKE_CURRENT_BINARY_DIR})
else ()
  add_custom_target(OSGeo.GDAL.Core)
endif ()

list(APPEND GDAL_SWIG_COMMON_INTERFACE_FILES
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/gdal_csharp_extend.i
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/gdal_csharp.i
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/gnm_csharp.i
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/ogr_csharp_extend.i
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/ogr_csharp.i
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/osr_csharp.i
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/swig_csharp_extensions.i
   ${PROJECT_SOURCE_DIR}/swig/include/csharp/typemaps_csharp.i)

# function for csharp wrapper build
function (gdal_csharp_wrap)
  # Setup
  set(_options)
  set(_oneValueArgs WRAPPER SWIG_INTERFACE NAMESPACE TARGET_SUBDIR)
  cmake_parse_arguments(_CSHARP "${_options}" "${_oneValueArgs}" "${_multiValueArgs}" ${ARGN})
  set(_CSHARP_WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR})

  # Run the SWIG interface build
  add_custom_command(
    # create the sub folder
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_WRAPPER}.cpp
    COMMAND ${CMAKE_COMMAND} -E make_directory ${_CSHARP_WORKING_DIRECTORY}
    # SWIG command
    COMMAND
      ${SWIG_EXECUTABLE} -namespace ${_CSHARP_NAMESPACE} -outdir ${_CSHARP_WORKING_DIRECTORY} -DSWIG2_CSHARP -dllimport
      ${_CSHARP_WRAPPER} -Wall -I${PROJECT_SOURCE_DIR}/swig/include -I${PROJECT_SOURCE_DIR}/swig/include/csharp
      -I${PROJECT_SOURCE_DIR}/gdal -c++ -csharp -o ${_CSHARP_WRAPPER}.cpp ${_CSHARP_SWIG_INTERFACE}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${GDAL_SWIG_COMMON_INTERFACE_FILES} ${PROJECT_SOURCE_DIR}/swig/include/csharp/typemaps_csharp.i
            ${_CSHARP_SWIG_INTERFACE})

  # add the wrapper dll
  set_source_files_properties(${_CSHARP_WRAPPER} PROPERTIES GENERATED 1)
  add_library(${_CSHARP_WRAPPER} SHARED ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_WRAPPER}.cpp)
  if (GDAL_CSHARP_ONLY)
    include_directories(${GDAL_INCLUDE_DIR})
    target_link_libraries(${_CSHARP_WRAPPER} PRIVATE ${GDAL_LIBRARY})
  else ()
    gdal_standard_includes(${_CSHARP_WRAPPER})
    target_link_libraries(${_CSHARP_WRAPPER} PRIVATE $<TARGET_NAME:${GDAL_LIB_TARGET_NAME}>)
  endif ()

  install(
    TARGETS ${_CSHARP_WRAPPER}
    COMPONENT csharp
    DESTINATION ${GDAL_CSHARP_INSTALL_DIR})
endfunction (gdal_csharp_wrap)

# function for xxx_csharp.dll build
function (gdal_csharp_dll)

  # Setup
  set(_options)
  set(_oneValueArgs TARGET TARGET_SUBDIR WRAP_DLL PACKAGE_NAME)
  set(_multiValueArgs DEPENDS SYSTEM_DEPENDS)
  cmake_parse_arguments(_CSHARP "${_options}" "${_oneValueArgs}" "${_multiValueArgs}" ${ARGN})
  get_filename_component(_root ${_CSHARP_TARGET} NAME_WE)

  if(WIN32)
      file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_root}.csproj" _CSHARP_PROJ)
      file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}" _CSHARP_PROJ_PATH)
      file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_CSHARP_TARGET}" _CSHARP_DLL_TARGET)
  else()
      set(_CSHARP_PROJ "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_root}.csproj")
      set(_CSHARP_PROJ_PATH "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}")
      set(_CSHARP_DLL_TARGET "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_CSHARP_TARGET}")
  endif()
  set(CSC_OPTIONS /unsafe /debug:full /target:library /out:${_CSHARP_DLL_TARGET})
  if (WIN32)
    list(APPEND CSC_OPTIONS /define:CLR4)
  endif ()
  set(_PACKAGE_NAME ${_CSHARP_PACKAGE_NAME})

  # Setup dependencies
  set(_dlls)
  set(_deps csharp_interface)
  if (_CSHARP_DEPENDS)
    foreach (_dep IN LISTS _CSHARP_DEPENDS)
      if(WIN32)
          file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}/${_dep}" _dep)
      else()
          set(_dep "${CMAKE_CURRENT_BINARY_DIR}/${_dep}")
      endif()
      get_filename_component(_filename ${_dep} NAME)
      list(APPEND _dlls ${_filename}.dll)
      list(APPEND CSC_OPTIONS /r:${_dep}.dll)
    endforeach ()
  endif (_CSHARP_DEPENDS)
  if (_CSHARP_SYSTEM_DEPENDS)
    foreach (_dep IN LISTS _CSHARP_SYSTEM_DEPENDS)
      if (_dep MATCHES "^OSGeo")
        list(APPEND _deps ${_dep})
      endif ()
    endforeach ()
  endif ()

  # run the c# build
  if (DOTNET_FOUND)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/dll_template.csproj"
                   "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_root}.csproj.in")
    file(
      GENERATE
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_root}-$<CONFIG>.csproj
      INPUT ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_root}.csproj.in)
    add_custom_command(
      COMMAND ${CMAKE_COMMAND} -E "copy_if_different"
              "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_root}-$<CONFIG>.csproj" "${_CSHARP_PROJ}"
      VERBATIM PRE_BUILD
      DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_root}-$<CONFIG>.csproj"
      OUTPUT ${_CSHARP_PROJ})
    add_dotnet(
      ${_CSHARP_PROJ}
      ${CSHARP_CONFIG}
      NAME
      ${_PACKAGE_NAME}
      VERSION
      ${_VERSION_STRING}
      OUTPUT_PATH
      ${_CSHARP_PROJ_PATH}
      DEPENDS
      ${_deps}
      PACKAGE
      ${_CSHARP_SYSTEM_DEPENDS})

  else ()
    if (CMAKE_VERBOSE_MAKEFILE)
      message(STATUS "BUILDING : " ${_CSHARP_TARGET} " : " ${CSHARP_COMPILER} ${CSC_OPTIONS} /out:${_CSHARP_TARGET})
    endif ()
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET}
      COMMAND
        ${CMAKE_COMMAND} "-DSOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}" "-DCSC_OPTIONS=${CSC_OPTIONS}"
        "-DCSHARP_COMPILER=${CSHARP_COMPILER}" "-DTARGET_SUBDIR=${_CSHARP_PROJ_PATH}"
        -DWORKING=${CMAKE_CURRENT_BINARY_DIR} -P "${CMAKE_CURRENT_SOURCE_DIR}/add_dll_xsc.cmake"
      COMMAND ${CMAKE_COMMAND} -E echo
              "copy ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_CSHARP_TARGET} ${CMAKE_CURRENT_BINARY_DIR}"
      COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_CSHARP_TARGET}
              ${CMAKE_CURRENT_BINARY_DIR}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      VERBATIM
      DEPENDS csharp_interface ${CMAKE_CURRENT_BINARY_DIR}/gdal.snk ${CMAKE_CURRENT_SOURCE_DIR}/AssemblyInfo.cs)
    add_custom_target(${_PACKAGE_NAME} DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET})
    if (_CSHARP_SYSTEM_DEPENDS)
      add_dependencies(${_PACKAGE_NAME} ${_CSHARP_SYSTEM_DEPENDS})
    endif ()
  endif ()

  set(_CSHARP_IMPORTS ${CMAKE_CURRENT_BINARY_DIR}/${_CSHARP_TARGET_SUBDIR}/${_CSHARP_TARGET})
  if (DOTNET_FOUND)
    list(APPEND ${CMAKE_CURRENT_BINARY_DIR}/${_PACKAGE_NAME}.${_VERSION_STRING}.nupkg)
  endif ()

  install(
    FILES ${_CSHARP_IMPORTS}
    COMPONENT csharp
    DESTINATION ${GDAL_CSHARP_INSTALL_DIR})

endfunction ()

# ######################################################################################################################
gdal_csharp_wrap(
  NAMESPACE
  OSGeo.GDAL
  WRAPPER
  gdalconst_wrap
  SWIG_INTERFACE
  ${PROJECT_SOURCE_DIR}/swig/include/gdalconst.i
  TARGET_SUBDIR
  const)

gdal_csharp_wrap(
  NAMESPACE
  OSGeo.OSR
  WRAPPER
  osr_wrap
  SWIG_INTERFACE
  ${PROJECT_SOURCE_DIR}/swig/include/osr.i
  TARGET_SUBDIR
  osr)

gdal_csharp_wrap(
  NAMESPACE
  OSGeo.OGR
  WRAPPER
  ogr_wrap
  SWIG_INTERFACE
  ${PROJECT_SOURCE_DIR}/swig/include/ogr.i
  TARGET_SUBDIR
  ogr)

gdal_csharp_wrap(
  NAMESPACE
  OSGeo.GDAL
  WRAPPER
  gdal_wrap
  SWIG_INTERFACE
  ${PROJECT_SOURCE_DIR}/swig/include/gdal.i
  TARGET_SUBDIR
  gdal)

gdal_csharp_dll(TARGET gdalconst_csharp.dll TARGET_SUBDIR const WRAP_DLL gdalconst_wrap PACKAGE_NAME OSGeo.GDAL.CONST)

gdal_csharp_dll(
  TARGET osr_csharp.dll
         TARGET_SUBDIR
         osr
         WRAP_DLL
         osr_wrap
         PACKAGE_NAME
         OSGeo.OSR
         SYSTEM_DEPENDS
         OSGeo.GDAL.Core)

gdal_csharp_dll(
  TARGET ogr_csharp.dll TARGET_SUBDIR ogr WRAP_DLL ogr_wrap
  DEPENDS osr_csharp
          gdalconst_csharp
          SYSTEM_DEPENDS
          OSGeo.OSR
          OSGeo.GDAL.CONST
          OSGeo.GDAL.Core
          PACKAGE_NAME
          OSGeo.OGR)

gdal_csharp_dll(
  TARGET gdal_csharp.dll TARGET_SUBDIR gdal
  DEPENDS osr_csharp
          ogr_csharp
          gdalconst_csharp
          WRAP_DLL
          gdal_wrap
          SYSTEM_DEPENDS
          OSGeo.OSR
          OSGeo.OGR
          OSGeo.GDAL.CONST
          OSGeo.GDAL.Core
          PACKAGE_NAME
          OSGeo.GDAL)

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "gdal;ogr;osr;const")

# ######################################################################################################################
# sample commands

function (gdal_build_csharp_sample)

  # setup arguments
  set(_options)
  set(_oneValueArgs SOURCE OUTPUT)
  set(_multiValueArgs DEPENDS SYSTEM_DEPENDS)
  cmake_parse_arguments(_GBCS "${_options}" "${_oneValueArgs}" "${_multiValueArgs}" ${ARGN})
  set(CSC_OPTIONS)

  # setup project file
  get_filename_component(_folder ${_GBCS_OUTPUT} NAME_WE)
  set(_GBCS_PROJ_PATH ${CMAKE_CURRENT_BINARY_DIR}/${_folder})
  set(_GBCS_PROJ ${_GBCS_PROJ_PATH}/${_folder})
  if(WIN32)
      file(TO_NATIVE_PATH "${_GBCS_PROJ}" _GBCS_PROJ_NATIVE)
      file(TO_NATIVE_PATH "${_GBCS_PROJ_PATH}" _GBCS_PROJ_PATH_NATIVE)
  else()
      set(_GBCS_PROJ_NATIVE "${_GBCS_PROJ}")
      set(_GBCS_PROJ_PATH_NATIVE "${_GBCS_PROJ_PATH}")
  endif()
  file(MAKE_DIRECTORY ${_GBCS_PROJ_PATH})

=== swig/python/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt.

if (CMAKE_CXX_FLAGS)
  string(REPLACE "-Werror " " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ")
  string(REPLACE "/WX " " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ")
endif ()

# SWIG generates wrapper sources
option(SWIG_REGENERATE_PYTHON "Generate python source with SWIG." OFF)

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/osgeo/")
set(GDAL_PYTHON_CSOURCE_DIR "${CMAKE_CURRENT_BINARY_DIR}/extensions/")
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/extensions/")
set(GDAL_PYTHON_CSOURCES
    ${GDAL_PYTHON_CSOURCE_DIR}/gdal_wrap.cpp ${GDAL_PYTHON_CSOURCE_DIR}/gdalconst_wrap.c
    ${GDAL_PYTHON_CSOURCE_DIR}/gnm_wrap.cpp ${GDAL_PYTHON_CSOURCE_DIR}/ogr_wrap.cpp
    ${GDAL_PYTHON_CSOURCE_DIR}/osr_wrap.cpp)

if (SWIG_REGENERATE_PYTHON)

  if ("${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
      message(WARNING "Builds from root directory with SWIG_REGENERATE_PYTHON=ON mostly work, but 'make clean' will remove the swig/python/extensions/* and swig/python/osgeo* generated files")
  endif()

  list(APPEND GDAL_SWIG_COMMON_INTERFACE_FILES
       ${PROJECT_SOURCE_DIR}/swig/include/python/callback.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/gdal_python.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/gnm_python.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/ogr_python.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/osr_python.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/python_exceptions.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/python_strings.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/typemaps_python.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/docs/ogr_datasource_docs.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/docs/ogr_driver_docs.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/docs/ogr_featuredef_docs.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/docs/ogr_feature_docs.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/docs/ogr_fielddef_docs.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/docs/ogr_geometry_docs.i
       ${PROJECT_SOURCE_DIR}/swig/include/python/docs/ogr_layer_docs.i)

  set(GDAL_PYTHON_PYSOURCES
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdal.py ${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdalconst.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/gnm.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/ogr.py ${CMAKE_CURRENT_BINARY_DIR}/osgeo/osr.py)
  include(GdalSwigBindings)
  gdal_swig_bindings(
    BINDING
    python
    ARGS
    -I${PROJECT_SOURCE_DIR}/swig/include/python/docs
    -py3
    -threads
    -relativeimport
    -outdir
    ${CMAKE_CURRENT_BINARY_DIR}/osgeo
    OUTPUT
    ${GDAL_PYTHON_PYSOURCES}
    ${GDAL_PYTHON_CSOURCES}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/modify_cpp_files.cmake)

  # gdal_array_wrap.cpp when NumPy exist
  if (Python_NumPy_FOUND)
    set(ARRAY_INPUT ${PROJECT_SOURCE_DIR}/swig/include/gdal_array.i)
    set(ARRAY_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/extensions/gdal_array_wrap.cpp)
    add_custom_command(
      OUTPUT ${ARRAY_OUTPUT} "${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdal_array.py"
      COMMAND
        ${SWIG_EXECUTABLE} -Wall -I${PROJECT_SOURCE_DIR}/swig/include -I${PROJECT_SOURCE_DIR}/swig/include/python
        -I${PROJECT_SOURCE_DIR}/swig/include/python/docs -py3 -threads -relativeimport -outdir
        ${CMAKE_CURRENT_BINARY_DIR}/osgeo ${SWIG_DEFINES} -I${PROJECT_SOURCE_DIR}/gdal -c++ -python -o ${ARRAY_OUTPUT}
        ${ARRAY_INPUT}
      DEPENDS ${ARRAY_INPUT}
              ${PROJECT_SOURCE_DIR}/swig/include/python/typemaps_python.i
              ${CMAKE_CURRENT_SOURCE_DIR}/modify_cpp_files.cmake
      COMMENT "Generate _gdal_array_wrap.so and gdal_array.py by SWiG command")
    list(APPEND GDAL_PYTHON_CSOURCES "${GDAL_PYTHON_CSOURCE_DIR}/gdal_array_wrap.cpp")
    list(APPEND GDAL_PYTHON_PYSOURCES "${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdal_array.py")
  endif ()

  if (NOT "${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
      add_custom_command(
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdalnumeric.py"
        COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/osgeo/gdalnumeric.py"
                "${CMAKE_CURRENT_BINARY_DIR}/osgeo"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/osgeo/gdalnumeric.py")
      list(APPEND GDAL_PYTHON_PYSOURCES "${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdalnumeric.py")
  endif()

  if (NOT "${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
      add_custom_command(
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/osgeo/__init__.py"
        COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/osgeo/__init__.py" "${CMAKE_CURRENT_BINARY_DIR}/osgeo"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/osgeo/__init__.py")
      list(APPEND GDAL_PYTHON_PYSOURCES "${CMAKE_CURRENT_BINARY_DIR}/osgeo/__init__.py")
  endif()

  foreach(_file IN ITEMS ${GDAL_PYTHON_CSOURCES})
      add_custom_command(
        OUTPUT ${_file}
        APPEND
        COMMAND ${CMAKE_COMMAND} ${WERROR_DEV_FLAG} "-DFILE=${_file}" -P ${CMAKE_CURRENT_SOURCE_DIR}/modify_cpp_files.cmake)
  endforeach()

  if (NOT Python_EXECUTABLE)
    message(FATAL_ERROR "Python_EXECUTABLE variable not set")
  endif()
  foreach(_file IN ITEMS ${GDAL_PYTHON_PYSOURCES})
      file(TO_NATIVE_PATH "${_file}" _native_file)
      add_custom_command(
        OUTPUT ${_file}
        APPEND
        COMMAND
          ${Python_EXECUTABLE} -m lib2to3 --fix=import --fix=next --fix=renames --fix=unicode --fix=ws_comma --fix=xrange
          --write --write-unchanged-files --nobackups  ${_native_file})
  endforeach()

  if (NOT "${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
      option(SWIG_COPY_REGENERATED_PYTHON_IN_SOURCE_DIR "Copy SWIG regenerated Python bindings into source directory." ON)
      if(SWIG_COPY_REGENERATED_PYTHON_IN_SOURCE_DIR)
          file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/extensions" GDAL_PYTHON_CSOURCE_SRC_DIR_NATIVE_PATH)
          foreach(_file IN ITEMS ${GDAL_PYTHON_CSOURCES})
              file(TO_NATIVE_PATH "${_file}" _native_file)
              add_custom_command(
                OUTPUT ${_file}
                APPEND
                COMMAND
                  ${CMAKE_COMMAND} -E copy_if_different
                  ${_native_file}
                  ${GDAL_PYTHON_CSOURCE_SRC_DIR_NATIVE_PATH})
          endforeach()

          file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/osgeo" GDAL_PYTHON_PYSOURCE_SRC_DIR_NATIVE_PATH)
          foreach(_file IN ITEMS ${GDAL_PYTHON_PYSOURCES})
              file(TO_NATIVE_PATH "${_file}" _native_file)
              add_custom_command(
                OUTPUT ${_file}
                APPEND
                COMMAND
                  ${CMAKE_COMMAND} -E copy_if_different
                  ${_native_file}
                  ${GDAL_PYTHON_PYSOURCE_SRC_DIR_NATIVE_PATH})
          endforeach()
      endif()
  endif()

elseif (NOT "${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
  set(GDAL_PYTHON_CSOURCES_SRC
      ${CMAKE_CURRENT_SOURCE_DIR}/extensions/gdal_wrap.cpp ${CMAKE_CURRENT_SOURCE_DIR}/extensions/gdalconst_wrap.c
      ${CMAKE_CURRENT_SOURCE_DIR}/extensions/gnm_wrap.cpp ${CMAKE_CURRENT_SOURCE_DIR}/extensions/ogr_wrap.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/extensions/osr_wrap.cpp)
  set(GDAL_PYTHON_PYSOURCES
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/__init__.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdal.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdalconst.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdalnumeric.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/gnm.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/ogr.py
      ${CMAKE_CURRENT_BINARY_DIR}/osgeo/osr.py)
  set(OSGEO_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/osgeo")
  set(OSGEO_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/osgeo/")
  if (Python_NumPy_FOUND)
    list(APPEND GDAL_PYTHON_CSOURCES "${GDAL_PYTHON_CSOURCE_DIR}/gdal_array_wrap.cpp")
    list(APPEND GDAL_PYTHON_CSOURCES_SRC "${CMAKE_CURRENT_SOURCE_DIR}/extensions/gdal_array_wrap.cpp")
    list(APPEND GDAL_PYTHON_PYSOURCES "${CMAKE_CURRENT_BINARY_DIR}/osgeo/gdal_array.py")
  endif ()
  add_custom_command(
    OUTPUT ${GDAL_PYTHON_PYSOURCES}
    COMMAND
      ${CMAKE_COMMAND} -E copy ${OSGEO_SOURCE_DIR}__init__.py ${OSGEO_SOURCE_DIR}gdal.py
      ${OSGEO_SOURCE_DIR}gdalconst.py ${OSGEO_SOURCE_DIR}gdalnumeric.py ${OSGEO_SOURCE_DIR}ogr.py
      ${OSGEO_SOURCE_DIR}osr.py ${OSGEO_SOURCE_DIR}gnm.py ${OSGEO_SOURCE_DIR}gdal_array.py "${OSGEO_BINARY_DIR}")
  set(GDAL_PYTHON_CSOURCE_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/extensions/")
  add_custom_command(
    OUTPUT ${GDAL_PYTHON_CSOURCES}
    COMMAND
      ${CMAKE_COMMAND} -E copy_if_different ${GDAL_PYTHON_CSOURCE_SRC_DIR}gdal_wrap.cpp
      ${GDAL_PYTHON_CSOURCE_SRC_DIR}gdalconst_wrap.c ${GDAL_PYTHON_CSOURCE_SRC_DIR}gnm_wrap.cpp
      ${GDAL_PYTHON_CSOURCE_SRC_DIR}ogr_wrap.cpp ${GDAL_PYTHON_CSOURCE_SRC_DIR}osr_wrap.cpp
      ${GDAL_PYTHON_CSOURCE_SRC_DIR}gdal_array_wrap.cpp ${GDAL_PYTHON_CSOURCE_DIR}
    DEPENDS ${GDAL_PYTHON_CSOURCES_SRC})
endif ()

function (symlink_or_copy source destination)

  if (CMAKE_VERSION VERSION_GREATER 3.14)
    file(
      CREATE_LINK ${source} ${destination}
      RESULT res
      SYMBOLIC)
    if (NOT res EQUAL 0)
      message(STATUS "Copying content of ${source} to ${destination}")
      execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${source} ${destination})
    endif ()
  else ()
    if (NOT CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
      execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${source} ${destination})
    else ()
      message(STATUS "Copying content of ${source} to ${destination}")
      execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${source} ${destination})
    endif ()
  endif ()

endfunction ()

if (NOT "${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
    symlink_or_copy(${CMAKE_CURRENT_SOURCE_DIR}/gdal-utils ${CMAKE_CURRENT_BINARY_DIR}/gdal-utils)
endif()
symlink_or_copy(${CMAKE_CURRENT_SOURCE_DIR}/gdal-utils/osgeo_utils ${CMAKE_CURRENT_BINARY_DIR}/osgeo_utils)

get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if (_isMultiConfig AND WIN32)
  set(ONLY_GENERATE_FOR_NON_DEBUG ON)
endif ()

if (Python_Interpreter_FOUND)
  if (ENABLE_GNM)
    set(GNM_ENABLED "True")
  else ()
    set(GNM_ENABLED "False")
  endif ()

  # Use the 'X.Y.Z' numbering scheme from libgdal by default for the gdal python package version number
  # And append a ".patch" if the patch is not 0.
  set(GDAL_PYTHON_VERSION "${GDAL_VERSION_NO_DEV_SUFFIX}")
  if( NOT "${GDAL_VERSION_BUILD}" STREQUAL "0" )
      string(APPEND GDAL_PYTHON_VERSION ".${GDAL_VERSION_BUILD}")
  endif()

  file(TO_NATIVE_PATH "${GDAL_PYTHON_CSOURCE_DIR}" GDAL_PYTHON_EXT_SOURCE_DIR)
  if (_isMultiConfig)
    set(GDAL_LIB_DIR "os.path.dirname('$<TARGET_FILE:${GDAL_LIB_TARGET_NAME}>')")
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in ${CMAKE_CURRENT_BINARY_DIR}/setup.py.tmp @ONLY)
    if (ONLY_GENERATE_FOR_NON_DEBUG)
      file(
        GENERATE
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/setup.py
        INPUT ${CMAKE_CURRENT_BINARY_DIR}/setup.py.tmp
        CONDITION "$<CONFIG:Release>")
      set(SETUP_PY_FILENAME "${CMAKE_CURRENT_BINARY_DIR}/setup_$<CONFIG>.py")
    else ()
      set(SETUP_PY_FILENAME "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
    endif ()
    file(
      GENERATE
      OUTPUT "${SETUP_PY_FILENAME}"
      INPUT ${CMAKE_CURRENT_BINARY_DIR}/setup.py.tmp)
  else ()
    # Do not use file(GENERATE) as, for some unknown reason, it would cause cmake to be reinvoked every time make is
    # involved
    get_target_property(_gdal_lib_directory ${GDAL_LIB_TARGET_NAME} LIBRARY_OUTPUT_DIRECTORY)
    set(GDAL_LIB_DIR "'${_gdal_lib_directory}'")
    set(SETUP_PY_FILENAME "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in ${SETUP_PY_FILENAME} @ONLY)
  endif ()

  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/README.rst ${CMAKE_CURRENT_BINARY_DIR}/README.rst @ONLY)

=== frmts/gtiff/libtiff/CMakeLists.txt ===
include(GdalDriverHelper)

add_library(
  libtiff OBJECT
  tif_dir.c
  tif_fax3.c
  tif_lzma.c
  tif_predict.h
  tif_vsi.c
  tiffiop.h
  t4.h
  tif_dir.h
  tif_fax3.h
  tif_lzw.c
  tif_print.c
  tif_warning.c
  tiffvers.h
  tif_aux.c
  tif_dirinfo.c
  tif_fax3sm.c
  tif_next.c
  tif_read.c
  tif_write.c
  uvcode.h
  tif_close.c
  tif_dirread.c
  tif_flush.c
  tif_strip.c
  tif_zip.c
  tif_codec.c
  tif_dirwrite.c
  tif_getimage.c
  tif_open.c
  tif_swab.c
  tif_zstd.c
  tif_webp.c
  tif_color.c
  tif_dumpmode.c
  tif_packbits.c
  tif_thunder.c
  tiff.h
  tif_compress.c
  tif_error.c
  tif_pixarlog.c
  tif_tile.c
  tiffconf.h
  tif_config.h
  tif_extension.c
  tif_luv.c
  tif_predict.c
  tif_version.c
  tif_lerc.c
  tiffio.h)
target_include_directories(libtiff PRIVATE $<TARGET_PROPERTY:cpl,SOURCE_DIR> $<TARGET_PROPERTY:cpl,BINARY_DIR>)
target_compile_definitions(libtiff PRIVATE -DDONT_DEPRECATE_SPRINTF -DHOST_FILLORDER=FILLORDER_LSB2MSB)
target_compile_options(libtiff PRIVATE ${GDAL_C_WARNING_FLAGS})

if (MSVC)
  # Suppress '<unnamed-tag>': structure was padded due to alignment specifier in tif_jpeg.c
  target_compile_options(libtiff PRIVATE /wd4324)
endif ()

target_compile_definitions(libtiff PRIVATE -DPIXARLOG_SUPPORT -DZIP_SUPPORT)

if (GDAL_USE_JPEG_INTERNAL OR GDAL_USE_JPEG)
  target_compile_definitions(libtiff PRIVATE -DJPEG_SUPPORT -DOJPEG_SUPPORT)
endif ()

# Include first internal libraries
if (GDAL_USE_ZLIB_INTERNAL)
  gdal_add_vendored_lib(libtiff libz)
endif ()

if (GDAL_USE_JPEG_INTERNAL)
  target_sources(libtiff PRIVATE tif_jpeg.c tif_ojpeg.c)
  gdal_add_vendored_lib(libtiff libjpeg)
endif ()

if (GDAL_USE_LERC_INTERNAL)
  target_compile_definitions(libtiff PRIVATE -DLERC_SUPPORT)
  gdal_add_vendored_lib(libtiff lerc)
endif ()

# Now external libraries

# Include libjpeg first so that if we want to use jpeg-turbo on homebrew
# /usr/local/opt/jpeg-turbo gets included first, before /usr/local/opt
# that contains libjpeg 9e
if (GDAL_USE_JPEG AND NOT GDAL_USE_JPEG_INTERNAL)
  # Use a separate object library so that external libjpeg headers are only applied to tif_jpeg.c and tif_ojpeg.c, but
  # not tif_jpeg_12.c !
  add_library(libtiff_jpeg OBJECT tif_jpeg.c tif_ojpeg.c)
  target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:libtiff_jpeg>)
  target_compile_options(libtiff_jpeg PRIVATE ${GDAL_C_WARNING_FLAGS})
  if (MSVC)
    # Suppress '<unnamed-tag>': structure was padded due to alignment specifier in tif_jpeg.c
    target_compile_options(libtiff_jpeg PRIVATE /wd4324)
  endif ()
  set_property(TARGET libtiff_jpeg PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
  target_compile_definitions(libtiff_jpeg PRIVATE -DJPEG_SUPPORT -DOJPEG_SUPPORT)
  target_include_directories(libtiff_jpeg PRIVATE $<TARGET_PROPERTY:cpl,SOURCE_DIR> $<TARGET_PROPERTY:cpl,BINARY_DIR>)
  gdal_target_link_libraries(libtiff_jpeg PRIVATE JPEG::JPEG)
  if (GDAL_USE_JPEG12_INTERNAL)
    target_compile_definitions(libtiff_jpeg PRIVATE -DJPEG_DUAL_MODE_8_12)
  endif ()
  if (RENAME_INTERNAL_TIFF_SYMBOLS)
    target_compile_definitions(libtiff_jpeg PRIVATE -DRENAME_INTERNAL_LIBTIFF_SYMBOLS)
  endif ()
endif ()

if (NOT GDAL_USE_ZLIB_INTERNAL)
  gdal_target_link_libraries(libtiff PRIVATE ZLIB::ZLIB)
endif ()

if (GDAL_USE_DEFLATE)
  target_compile_definitions(libtiff PRIVATE -DLIBDEFLATE_SUPPORT)
  gdal_target_link_libraries(libtiff PRIVATE Deflate::Deflate)
endif ()

if ((GDAL_USE_JPEG OR GDAL_USE_JPEG_INTERNAL) AND GDAL_USE_JPEG12_INTERNAL)
  target_sources(libtiff PRIVATE tif_jpeg_12.c)
  target_compile_definitions(libtiff PRIVATE -DJPEG_DUAL_MODE_8_12)
  target_include_directories(libtiff PRIVATE $<TARGET_PROPERTY:libjpeg12,BINARY_DIR>)
endif ()

if (GDAL_USE_LIBLZMA)
  target_compile_definitions(libtiff PRIVATE -DLZMA_SUPPORT)
  gdal_target_link_libraries(libtiff PRIVATE LibLZMA::LibLZMA)
endif ()

if (GDAL_USE_ZSTD)
  target_compile_definitions(libtiff PRIVATE -DZSTD_SUPPORT)
  gdal_target_link_libraries(libtiff PRIVATE ${ZSTD_TARGET})
endif ()

if (GDAL_USE_WEBP)
  target_compile_definitions(libtiff PRIVATE -DWEBP_SUPPORT)
  gdal_target_link_libraries(libtiff PRIVATE WEBP::WebP)
endif ()

if (NOT GDAL_USE_LERC_INTERNAL AND GDAL_USE_LERC)
  target_compile_definitions(libtiff PRIVATE -DLERC_SUPPORT)
  gdal_target_link_libraries(libtiff PRIVATE LERC::LERC)
endif ()

if (RENAME_INTERNAL_TIFF_SYMBOLS)
  target_compile_definitions(libtiff PUBLIC -DRENAME_INTERNAL_LIBTIFF_SYMBOLS)
endif ()

if (MSVC)
  if (CMAKE_CL_64)
    target_compile_definitions(libtiff PRIVATE -D_WIN64)
  endif ()
endif ()

set_target_properties(libtiff PROPERTIES CXX_STANDARD 11)
set_property(TARGET libtiff PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:libtiff>)

=== ogr/ogrsf_frmts/gpkg/CMakeLists.txt ===
# GeoPackage has raster and vector drivers in single module and referred from mbtiles driver
add_gdal_driver(
  TARGET ogr_GeoPackage
  DEF GPKG_ENABLED
  SOURCES ogr_geopackage.h
          gpkgmbtilescommon.h
          ogrgeopackageutility.h
          ogrgeopackagedatasource.cpp
          ogrgeopackagedriver.cpp
          ogrgeopackagelayer.cpp
          ogrgeopackageselectlayer.cpp
          ogrgeopackagetablelayer.cpp
          ogrgeopackageutility.cpp
          gdalgeopackagerasterband.cpp
  STRONG_CXX_WFLAGS
  BUILTIN)
gdal_standard_includes(ogr_GeoPackage)
target_include_directories(
  ogr_GeoPackage PRIVATE $<TARGET_PROPERTY:alg,SOURCE_DIR> ${GDAL_RASTER_FORMAT_SOURCE_DIR}/mem
                         ${GDAL_VECTOR_FORMAT_SOURCE_DIR}/sqlite  $<TARGET_PROPERTY:ogrsf_generic,SOURCE_DIR>)

gdal_target_link_libraries(ogr_GeoPackage PRIVATE SQLite::SQLite3)
if (SQLite3_HAS_COLUMN_METADATA)
  target_compile_definitions(ogr_GeoPackage PRIVATE -DSQLITE_HAS_COLUMN_METADATA)
endif ()

=== ogr/ogrsf_frmts/sqlite/CMakeLists.txt ===
# depends from gpkg, osm
add_gdal_driver(
  TARGET ogr_SQLite
  BUILTIN
  SOURCES ogr_sqlite.h
          ogrsqlite3ext.h
          ogrsqliteexecutesql.h
          ogrsqlitesqlfunctions.h
          ogrsqlitevirtualogr.h
          ogrsqliteutility.h
          ogrsqlitedatasource.cpp
          ogrsqlitedriver.cpp
          ogrsqlitelayer.cpp
          ogrsqliteselectlayer.cpp
          ogrsqlitesinglefeaturelayer.cpp
          ogrsqlitetablelayer.cpp
          ogrsqlitevfs.cpp
          ogrsqliteviewlayer.cpp
          ogrsqliteexecutesql.cpp
          ogrsqlitevirtualogr.cpp
          ogrsqliteutility.cpp
          ogrsqliteapiroutines.c
          rasterlite2_header.h
          rasterlite2.cpp)
gdal_standard_includes(ogr_SQLite)

target_compile_definitions(ogr_SQLite PRIVATE -DHAVE_SQLITE)
gdal_target_link_libraries(ogr_SQLite PRIVATE SQLite::SQLite3)
gdal_target_link_libraries(ogr_SQLite PRIVATE PROJ::proj)

if (SQLite3_HAS_LOAD_EXTENSION)
  option(OGR_SQLITE_ALLOW_LOAD_EXTENSIONS "Whether SQLite extension loading is enabled through the OGR_SQLITE_LOAD_EXTENSIONS configuration option" ON)
  if (OGR_SQLITE_ALLOW_LOAD_EXTENSIONS)
    target_compile_definitions(ogr_SQLite PRIVATE -DOGR_SQLITE_ALLOW_LOAD_EXTENSIONS)
  endif()
endif()

if (GDAL_USE_PCRE2)
  target_compile_definitions(ogr_SQLite PRIVATE -DHAVE_PCRE2)
  gdal_target_link_libraries(ogr_SQLite PRIVATE PCRE2::PCRE2-8)
elseif (GDAL_USE_PCRE)
  target_compile_definitions(ogr_SQLite PRIVATE -DHAVE_PCRE)
  gdal_target_link_libraries(ogr_SQLite PRIVATE PCRE::PCRE)
endif ()

if (SQLite3_HAS_COLUMN_METADATA)
  target_compile_definitions(ogr_SQLite PRIVATE -DSQLITE_HAS_COLUMN_METADATA)
endif ()

if (SQLite3_HAS_NON_DEPRECATED_AUTO_EXTENSION)
  target_compile_definitions(ogr_SQLite PRIVATE -DSQLITE_HAS_NON_DEPRECATED_AUTO_EXTENSION)
endif ()

if (GDAL_USE_SPATIALITE)
  target_compile_definitions(ogr_SQLite PRIVATE -DHAVE_SPATIALITE)
  gdal_target_link_libraries(ogr_SQLite PRIVATE SPATIALITE::SPATIALITE)
  if (SPATIALITE_VERSION_STRING VERSION_GREATER 4.1.2 OR SPATIALITE_VERSION_STRING VERSION_EQUAL 4.1.2)
    target_compile_definitions(ogr_SQLite PRIVATE -DSPATIALITE_412_OR_LATER)
  endif ()
endif ()
if (GDAL_USE_RASTERLITE2)
  target_compile_definitions(ogr_SQLite PRIVATE -DHAVE_RASTERLITE2)
  gdal_target_link_libraries(ogr_SQLite PRIVATE RASTERLITE2::RASTERLITE2)
endif ()

# Test utility
add_executable(test_load_virtual_ogr EXCLUDE_FROM_ALL test_load_virtual_ogr.c)
gdal_standard_includes(test_load_virtual_ogr)
target_link_libraries(test_load_virtual_ogr PRIVATE SQLite::SQLite3)
if (GDAL_USE_SPATIALITE)
  target_include_directories(test_load_virtual_ogr PRIVATE ${SPATIALITE_INCLUDE_DIRS})
  target_compile_definitions(test_load_virtual_ogr PRIVATE -DHAVE_SPATIALITE)
  target_link_libraries(test_load_virtual_ogr PRIVATE SPATIALITE::SPATIALITE)
  if (SPATIALITE_AMALGAMATION)
    target_compile_definitions(test_load_virtual_ogr PRIVATE -DSPATIALITE_AMALGAMATION)
  endif ()
endif ()

# Test sqlite3 extension
find_path(SQLITE3EXT_INCLUDE_DIR NAMES sqlite3ext.h)
if (SQLITE3EXT_INCLUDE_DIR)
    add_library(my_test_sqlite3_ext MODULE my_test_sqlite3_ext.c)
    gdal_standard_includes(my_test_sqlite3_ext)
    get_target_property(PLUGIN_OUTPUT_DIR ${GDAL_LIB_TARGET_NAME} PLUGIN_OUTPUT_DIR)
    set_target_properties(my_test_sqlite3_ext
                          PROPERTIES
                          PREFIX ""
                          LIBRARY_OUTPUT_DIRECTORY ${PLUGIN_OUTPUT_DIR}
                          SKIP_BUILD_RPATH YES
                          )
    target_link_libraries(my_test_sqlite3_ext PRIVATE SQLite::SQLite3)
endif()

=== debian/changelog ===
gdal (3.6.0+dfsg-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 20 Nov 2022 06:29:33 +0100

gdal (3.6.0+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 11 Nov 2022 11:51:15 +0100

gdal (3.6.0~rc2+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for other architectures.
  * Include ogr_layer_algebra.1 in gdal-bin.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 07 Nov 2022 05:45:10 +0100

gdal (3.6.0~rc1+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.
  * Rename library package for SONAME bump.
  * Enable JPEGXL driver.
  * Refresh patches.
  * Update symbols for amd64.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 03 Nov 2022 19:57:08 +0100

=== debian/control ===
Source: gdal
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-python,
               doxygen,
               graphviz,
               chrpath,
               bash-completion,
               libarmadillo-dev,
               libblosc-dev,
               libcfitsio-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libdeflate-dev,
               libexpat1-dev,
               libfreexl-dev (>= 1.0.0),
               libfyba-dev,
               libgeos-dev,
               libgeotiff-dev (>= 1.5.0),
               libgif-dev,
               libhdf4-alt-dev,
               libhdf5-dev (>= 1.8.8),
               libheif-dev,
               libjpeg-dev,
               libjson-c-dev,
               libjxl-dev,
               libkml-dev (>= 1.3.0~rc0-3),
               liblz4-dev,
               liblzma-dev,
       default-libmysqlclient-dev,
               libnetcdf-dev (>= 1:4.0.0),
               libogdi-dev,
               libopenjp2-7-dev,
               libpcre2-dev,
               libpng-dev,
               libpoppler-private-dev,
               libpq-dev,
               libproj-dev (>= 6.0.0),
               libqhull-dev,
               libspatialite-dev,
               libsqlite3-dev,
               libtiff-dev,
               liburiparser-dev,
               libwebp-dev,
               libxerces-c-dev,
               libxml2-dev,
               libzstd-dev,
               netcdf-bin,
               patch,
               pkg-config,
               pkg-kde-tools,
               python3-all-dev,
               python3-numpy,
               python3-distutils,
               python3-setuptools,
               swig,
               unixodbc-dev (>= 2.2.11),
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/gdal
Vcs-Git: https://salsa.debian.org/debian-gis-team/gdal.git
Homepage: http://www.gdal.org/

Package: libgdal32
Architecture: any
Section: libs
Depends: gdal-data (>= ${source:Version}),
         gdal-plugins (>= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: proj-bin
Description: Geospatial Data Abstraction Library
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports many popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains the shared library.

Package: libgdal-dev
Architecture: any
Section: libdevel
Depends: libgdal32 (= ${binary:Version}),
         libc6-dev,
         libarmadillo-dev,
         libblosc-dev,
         libcfitsio-dev,
         libcurl4-gnutls-dev | libcurl-ssl-dev,
         libdeflate-dev,
         libexpat1-dev,
         libfreexl-dev,
         libfyba-dev,
         libgeos-dev,
         libgeotiff-dev (>= 1.5.0),
         libgif-dev,
         libhdf4-alt-dev,
         libhdf5-dev,
         libheif-dev,
         libjpeg-dev,
         libjson-c-dev,
         libjxl-dev,
         libkml-dev,
         libltdl-dev,
         liblz4-dev,
         liblzma-dev,
 default-libmysqlclient-dev,
         libnetcdf-dev,
         libogdi-dev,
         libopenjp2-7-dev,
         libpcre2-dev,
         libpng-dev,
         libpoppler-private-dev,
         libpq-dev,
         libproj-dev (>= 6.0.0),
         libqhull-dev,
         libspatialite-dev,
         libsqlite3-dev,
         libtiff-dev,
         liburiparser-dev,
         libwebp-dev,
         libxerces-c-dev,
         libxml2-dev,
         libzstd-dev,
         unixodbc-dev,
         ${misc:Depends}
Description: Geospatial Data Abstraction Library - Development files
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports many popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains the files needed to develop a software that
 will use the GDAL/OGR (headers, static objects, configuration script).

Package: gdal-bin
Architecture: any
Depends: python3-gdal (= ${binary:Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: libgdal-grass
Breaks: gdal-bin (<< 1.10.0-0~),
        python-gdal (<< 2.4.3~)
Replaces: python-gdal (<< 2.4.3~)
Description: Geospatial Data Abstraction Library - Utility programs
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains utility programs, based on GDAL/OGR library,
 namely gdal_translate, gdalinfo, gdaladdo, gdalwarp, ogr2ogr, ogrinfo,
 ogrtindex.

Package: gdal-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Geospatial Data Abstraction Library - Data files
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains the GDAL data files.

Package: gdal-plugins
Architecture: any
Depends: ${misc:Depends}
Description: Geospatial Data Abstraction Library - Plugins
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains data for the plugins.

Package: python3-gdal
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: gdal-bin
Description: Python 3 bindings to the Geospatial Data Abstraction Library
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains Python 3 bindings for the GDAL/OGR library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Original debian package by Alessandro Amici 2002-2003.
# Currently maintained by DebianGis contributors.
# Based on: GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

PYVERS=$(shell py3versions -sv)
PYDEF=$(shell py3versions -dv)
SWIGVER=$(shell swig -version |grep Version|cut -d' ' -f3|sed -e 's/\.//g')

GDALVER=$(shell cat VERSION|sed -e 's/\./ /g')
GDAL_MAJOR=$(word 1,$(GDALVER))
GDAL_MINOR=$(word 2,$(GDALVER))
GDAL_PATCH=$(word 3,$(GDALVER))

ifeq (,$(DEB_HOST_MULTIARCH))
  DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
endif

# See: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=98189
ifneq (,$(filter $(DEB_HOST_ARCH),sh3 sh4))
  export DEB_CXXFLAGS_MAINT_APPEND=-fno-guess-branch-probability
endif

versions:
	@echo Gdal version: $(GDAL_MAJOR).$(GDAL_MINOR).$(GDAL_PATCH)
	@echo Swig version: $(SWIGVER)
	@echo Python default: $(PYDEF)
	@echo Python versions: $(PYVERS)

%:
	dh $@ --with python3,pkgkde_symbolshelper --buildsystem cmake

override_dh_auto_clean:
	for V in $(PYVERS); do \
		dh_auto_clean --builddir=build-py$$V ; \
	done

override_dh_auto_configure:
	for V in $(PYVERS); do \
		dh_auto_configure --builddir=build-py$$V -- \
			-DPython_LOOKUP_VERSION=$$V \
			-DBUILD_DOCS=OFF \
			-DBUILD_PYTHON_BINDINGS:BOOL=ON \
			-DCMAKE_INSTALL_INCLUDEDIR=include/gdal \
			-DGDAL_HIDE_INTERNAL_SYMBOLS=ON \
			-DRENAME_INTERNAL_TIFF_SYMBOLS=ON \
			-DRENAME_INTERNAL_GEOTIFF_SYMBOLS=ON \
			-DGDAL_USE_ARMADILLO=ON \
			-DGDAL_USE_BLOSC=ON \
			-DGDAL_USE_CFITSIO=ON \
			-DGDAL_USE_CURL=ON \
			-DGDAL_USE_DEFLATE=ON \
			-DGDAL_USE_ECW=OFF \
			-DGDAL_USE_EXPAT=ON \
			-DGDAL_USE_FREEXL=ON \
			-DGDAL_USE_FYBA=ON \
			-DGDAL_USE_GEOS=ON \
			-DGDAL_USE_GEOTIFF=ON \
			-DGDAL_USE_HDF5=ON \
			-DGDAL_USE_HEIF=ON \
			-DGDAL_USE_JSONC=ON \
			-DGDAL_USE_JXL=ON \
			-DGDAL_USE_LERC_INTERNAL=ON \
			-DGDAL_USE_LIBKML=ON \
			-DGDAL_USE_LIBLZMA=ON \
			-DGDAL_USE_LZ4=ON \
			-DGDAL_USE_MRSID=OFF \
			-DGDAL_USE_MYSQL=ON \
			-DGDAL_USE_NETCDF=ON \
			-DGDAL_USE_ODBC=ON \
			-DGDAL_USE_OGDI=ON \
			-DGDAL_USE_OPENCAD_INTERNAL=ON \
			-DGDAL_USE_OPENJPEG=ON \
			-DGDAL_USE_PCRE2=ON \
			-DGDAL_USE_POPPLER=ON \
			-DGDAL_USE_POSTGRESQL=ON \
			-DGDAL_USE_QHULL=ON \
			-DGDAL_USE_SPATIALITE=ON \
			-DGDAL_USE_SQLITE3=ON \
			-DGDAL_USE_TIFF=ON \
			-DGDAL_USE_WEBP=ON \
			-DGDAL_USE_XERCESC=ON \
			-DGDAL_USE_ZSTD=ON \
		; \
	done

override_dh_auto_build:
	for V in $(PYVERS); do \
		dh_auto_build --builddir=build-py$$V ; \
	done

override_dh_auto_test:
	for V in $(PYVERS); do \
		dh_auto_test --builddir=build-py$$V ; \
	done

override_dh_auto_install:
	for V in $(PYVERS); do \
		dh_auto_install --builddir=build-py$$V ; \
	done

	# install man pages
	install -o root -g root -d $(CURDIR)/debian/tmp/usr/share/man/man1
	install -o root -g root -m 644 $(CURDIR)/man/man1/*.1 $(CURDIR)/debian/tmp/usr/share/man/man1

	# removing useless autogenerated man pages
	rm -f $(CURDIR)/debian/tmp/usr/share/man/man1/_*_apps_.1

	# removing license file
	rm -f $(CURDIR)/debian/tmp/usr/share/gdal/LICENSE.TXT

	# removing embedded rpath in main lib
	-find $(CURDIR)/debian/tmp/usr/lib -type f -name "*.so*" -exec chrpath --delete {} \;

	# copy sample programs for python3-gdal
	install -o root -g root -d $(CURDIR)/debian/tmp/usr/share/doc/python3-gdal/examples
	install -o root -g root -m 644 $(CURDIR)/swig/python/gdal-utils/osgeo_utils/samples/*.py $(CURDIR)/debian/tmp/usr/share/doc/python3-gdal/examples/.
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/python3-gdal/examples/__init__.py

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

override_dh_installdocs:
	dh_installdocs -A third_party/LercLib/NOTICE

override_dh_python3:
	dh_python3 -X.info -pgdal-bin -ppython3-gdal --shebang=/usr/bin/python3
	dh_numpy3 -pgdal-bin -ppython3-gdal

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)
